#include<conio.h>
#include<stdio.h>
#include<stdlib.h>
#include<allegro.h>
#include"ninarow.h"

GameBoard SetupFiveStone(int First)
{
 GameBoard theGame;
 
 theGame.Size = 19;
 theGame.Done = 0;
 theGame.MovesRemaining = 19*19;
 theGame.PlayerTurn = First;
 theGame.Grid = (char **)malloc(theGame.Size * sizeof(char *));
 int i;
 for(i = 0; i < theGame.Size; i++)
   theGame.Grid[i] = (char *)malloc(theGame.Size * sizeof(char));

 int j;
 for(i = 0; i < theGame.Size; i++)
   for(j = 0; j < theGame.Size; j++)
     theGame.Grid[i][j] = '0';

 return theGame;
}

int CheckBoard(int X, int Y, GameBoard theGame, int InARow)
{
 int CurrentTotal = 1;
 int PosX = X;
 int PosY = Y;
 int Block = 0;
 char Player = theGame.Grid[X][Y];

 while(!Block)
 {
  PosX--;
  if(PosX < 0 || theGame.Grid[PosX][PosY] != Player)
  {
   PosX = X;
   while(!Block)
   {
    PosX++;
    if(PosX > theGame.Size-1 || theGame.Grid[PosX][PosY] != Player)    
      Block = 1;
    else CurrentTotal++;
   }
  }
  else CurrentTotal++;
 }
 if(CurrentTotal >= 5) return 1;
 else CurrentTotal = 1;

 Block = 0;
 PosX = X;
 PosY = Y;

 while(!Block)
 {
  PosY--;
  if(PosY < 0 || theGame.Grid[PosX][PosY] != Player)
  {
   PosY = Y;
   while(!Block)
   {
    PosY++;
    if(PosY > theGame.Size-1 || theGame.Grid[PosX][PosY] != Player)    
      Block = 1;
    else CurrentTotal++;
   }
  }
  else CurrentTotal++;
 }
 if(CurrentTotal >= 5) return 1;
 else CurrentTotal = 1;

 Block = 0;
 PosX = X;
 PosY = Y;

 while(!Block)
 {
  PosY--;
  PosX--;
  if(PosY < 0 || PosX < 0 || theGame.Grid[PosX][PosY] != Player)
  {
   PosX = X;
   PosY = Y;
   while(!Block)
   {
    PosY++;
    PosX++;
    if(PosX > theGame.Size-1 || PosY > theGame.Size-1 || theGame.Grid[PosX][PosY] != Player) 
      Block = 1;
    else CurrentTotal++;
   }
  }
  else CurrentTotal++;
 }
 if(CurrentTotal >= 5) return 1;
 else CurrentTotal = 1;

 Block = 0;
 PosX = X;
 PosY = Y;

 while(!Block)
 {
  PosY--;
  PosX++;
  if(PosY < 0 || PosX > theGame.Size-1 || theGame.Grid[PosX][PosY] != Player)
  {
   PosX = X;
   PosY = Y;
   while(!Block)
   {
    PosY++;
    PosX--;
    if(PosX < 0 || PosY > theGame.Size-1 || theGame.Grid[PosX][PosY] != Player) 
      Block = 1;
    else CurrentTotal++;
   }
  }
  else CurrentTotal++;
 }
 if(CurrentTotal >= 5) return 1;
 else CurrentTotal = 1;

 return 0; 
}


void PrintFiveStone(GameBoard theGame, int X, int Y)
{
 textcolor(0);
 textbackground(6);

 int x, y;
 for(y = 0; y < 19; y++)
 {
  gotoxy(0+10, y+2);
  for(x = 0; x < 19; x++)
  {
   if(x == X && y == Y) textbackground(3);
   else textbackground(6);
   if(theGame.Grid[x][y] == 'B') 
    cprintf("@");
   else if(theGame.Grid[x][y] == 'W') 
   {
    textcolor(15);
    cprintf("@");
    textcolor(0);
   }
   else if(x == 0)
   {
    if(y == 0) cprintf("%c", 218);
    else if(y == 18) cprintf("%c", 192);
    else cprintf("%c", 195);
   }
   else if(x == 18)
   {
    if(y == 0) cprintf("%c", 191);
    else if(y == 18) cprintf("%c", 217);
    else cprintf("%c", 180);
   }   
   else if(y == 0) cprintf("%c", 194);
   else if(y == 18) cprintf("%c", 193);
   else cprintf("%c",197);
  }
 }
}


void PlayFiveStone()
{
 GameBoard FiveStone = SetupFiveStone(0);
 int X = 9; 
 int Y = 9;
 PrintFiveStone(FiveStone, X, Y);  
 
 while((!key[KEY_ESC]) && FiveStone.Done == 0)
 {
  readkey();
  if(key[KEY_SPACE])
  {
   if(FiveStone.Grid[X][Y] == '0')
   {
    if(FiveStone.PlayerTurn) FiveStone.Grid[X][Y] = 'B';
    else FiveStone.Grid[X][Y] = 'W';
    FiveStone.PlayerTurn = (FiveStone.PlayerTurn + 1) % 2;
    FiveStone.MovesRemaining--;
    if(FiveStone.MovesRemaining <= 0) FiveStone.Done = 1;
    FiveStone.Done += CheckBoard(X, Y, FiveStone, 5);
   }
  }
  if(key[KEY_LEFT]) X--;
  if(key[KEY_RIGHT]) X++;
  if(key[KEY_UP]) Y--;
  if(key[KEY_DOWN]) Y++; 

  if(X > 18) X = 0;
  else if(X < 0) X = 18;
  else if(Y > 18) Y = 0;
  else if(Y < 0) Y = 18;
  PrintFiveStone(FiveStone, X, Y); 
 }
}


int main()
{
 allegro_init();
 install_timer();
 install_keyboard();	
  _setcursortype(_NOCURSOR);
 clrscr();
 PlayFiveStone(); 
 _setcursortype(_NORMALCURSOR);
 return 1;
}

